------------------------------------------------------------------------------------------------------------------------------------------------
--"DDS Converter"
--"produced by apras();"
--"http://www.apras.net/"
--
--
--memo
--V[ŎgpĂeNX`t@CDDS`ɕϊ܂B
--"NVIDIA Texture Tools 2" K{łB
--
--
--
--
--How to use
-- 1, "nvcompress.exe" include path {^ nvcompress.exe ܂܂pXI
-- 2, Xgr[ɓo^Ăt@Ĉϊ̂̍[`FbN
-- 3, Compression ňk`I
-- 4, Output path ŏo͐I
-- 5, Convert ŕϊJn
--
--
--History
--2009/01/20 1.00	First release
--
--
--ɂ񂵂ČlIɎĝ́BĔzzƂ́~B
--zƂ̓[Rgł肢܂B
------------------------------------------------------------------------------------------------------------------------------------------------
try
(
	--gc light:true
	cui.UnRegisterDialogBar dcRoll 
	destroyDialog dcRoll 
)
catch
(
)

struct FileInfo
(
	index,
	active,
	FullPath,
	Directory,
	FileName,
	Extension
)
------------------------------------------------------------------------
--
--
--[AEg`
------------------------------------------------------------------------
rollout dcRoll "DDS Converter"
(
	-- [Jϐ
	------------------------------------------------------------------------
	local mineVersion = 1.00
	local m_fileList = #()
	local m_exeFilePath = ""
	local m_outPutFilePath = ""
	local m_compression = 1
	local m_excludeExtension = #(".max", ".bip", ".xaf", ".chr")
	local m_compareFlag = #(true, true, true)
	------------------------------------------------------------------------
	--
	--
	-- C^[tF[X`
	------------------------------------------------------------------------
	dotNetControl list1 "System.Windows.Forms.ListView" width:760 height:256  pos:[10, 10]
	groupBox fixPanel "Option Panel" width:160 height:256 pos:[780,10]
	button m_bt6 "\"nvcompress.exe\" include path"width:150 height:18 enabled:true pos:[785, 30]
	button m_bt1 "Check All" width:150 height:18 enabled:true pos:[785,50]
	button m_bt2 "Uncheck All" width:150 height:18 enabled:true pos:[785,70]
	--
	dropdownlist m_dl1 "Compression" items:#("rgba", "DXT1", "DXT1nm - normal map", "DXT1a", "DXT3", "DXT5", 	"DXT5nm - normal map", "ATI1", "3Dc/ATI2") width:148 height:20 pos:[787,95]
	--
	edittext m_et1 "Output path"fieldWidth:125 labelOnTop:true pos:[787, 138]
	button m_bt3 "..." width:18 height:18 enabled:true pos:[917,155]
	--
	button m_bt4 "Convert" width:150 height:18 enabled:true pos:[785,180]
	button m_bt5 "Reset" width:150 height:18 enabled:true pos:[785,200]
	--
	progressbar m_prog1 width:150 height:10 color:[96,96,96] pos:[785,225]
	--
	button m_bt7 "update check" width:150 height:18 enabled:false pos:[785,242]
	--
	hyperLink m_hl1 "DDS Converter 1.0 -- 01/20/2009"	pos:[780,271] address:"http://www.apras.net/" color:black hoverColor:black visitedColor:black
	--
	------------------------------------------------------------------------
	--
	--
	-- [J֐
	------------------------------------------------------------------------
	--
	-- t@Cr
	fn compareName v1 v2 =
	(
		local _v1Str =  v1.FileName +  v1.Extension
		local _v2Str =  v2.FileName +  v2.Extension
		
		local _small  = -1
		local _big = 1
		
		if (not m_compareFlag[1]) then
		(
			_small = 1
			_big = -1
		)
		
		case of
		(
			( _v1Str < _v2Str): _small
			( _v1Str > _v2Str): _big
			default: 0
		)
	)
	--
	-- pXr
	fn comparePath v1 v2 =
	(
		local _v1Str =  v1.Directory
		local _v2Str =  v2.Directory
		
		local _small  = -1
		local _big = 1
		
		if (not m_compareFlag[2]) then
		(
			_small = 1
			_big = -1
		)
		
		case of
		(
			( _v1Str < _v2Str): _small
			( _v1Str > _v2Str): _big
			default: 0
		)
	)
	--
	--@gqr
	fn compareExtension v1 v2 =
	(
		local _v1Str =  v1.Extension
		local _v2Str =  v2.Extension
		
		local _small  = -1
		local _big = 1
		
		if (not m_compareFlag[3]) then
		(
			_small = 1
			_big = -1
		)
		
		case of
		(
			( _v1Str < _v2Str): _small
			( _v1Str > _v2Str): _big
			default: 0
		)
	)	
	--
	-- init@CXV
	fn keyInit =
	(
		local _iniFilePath = (getDir #scripts) + "\\DDSConverter.ini"
		if ((getFiles _iniFilePath).count != 0) then
		(
			local _dir = GetINISetting _iniFilePath "Directories" "nvcompress"
			if (_dir != "") then
			(
				m_bt6.text = "nvcompress.exe"
				m_exeFilePath = _dir as string
				m_bt6.enabled = false
			)
			--
			local _outDir = GetINISetting _iniFilePath "Directories" "output"
			if (_outDir != "") then
			(
				m_et1.text = _outDir
				m_outPutFilePath = _outDir
			)
			--
			local _format = GetINISetting _iniFilePath "Options" "compression"
			if (_format != "") then
			(
				
				m_dl1.selection = _format as Integer
				m_compression = _format as Integer
			)
			else
			(
				setINISetting _iniFilePath "Options" "compression" (m_compression as string) 
			)			
			--
		)else
		(
			createFile _iniFilePath
		)
	)
	--
	-- exet@CύX
	fn setExeFilePath =
	(
		local _iniFilePath = (getDir #scripts) + "\\DDSConverter.ini"
		local _folderPath = getSavePath caption:"Example \"C:\\Program Files\\NVIDIA Corporation\\NVIDIA Texture Tools 2\\bin\"" initialDir:m_exeFilePath
		if (_folderPath != undefined) then
		(
			if ((getFiles (_folderPath + "\\nvcompress.exe")).count != 0) then
			(
				m_bt6.text = "nvcompress.exe"
				setINISetting _iniFilePath "Directories" "nvcompress" _folderPath
				m_bt6.enabled = false				
				--
			)
			else
			(
				messageBox("\"nvcompress.exe\" could not be found")
			)
		)
		else
		(
		)
	)
	--
	-- o̓pXύX
	fn setOutPutPath = 
	(
		local _iniFilePath = (getDir #scripts) + "\\DDSConverter.ini"
		local _folderPath = getSavePath caption:"" initialDir:m_outPutFilePath
		if (_folderPath != undefined) then
		(
			m_et1.text = _folderPath
			m_outPutFilePath = _folderPath
			setINISetting _iniFilePath "Directories" "output" _folderPath
		)
		else
		(
		)
	)
	--
	-- kύX
	fn compressionChange index = 
	(
		local _iniFilePath = (getDir #scripts) + "\\DDSConverter.ini"
		m_compression = index
		setINISetting _iniFilePath "Options" "fromat" (index as string)
	)
	--
	-- t@CW
	fn fileCollector =
	(
		m_fileList = #()
		local _index = 0
		local _list = #()
		local _ioPath = dotNetClass "System.IO.Path"
		ATSOps.Refresh() 
		ATSOps.GetFiles &_list
		--
		for item in _list do
		(
			local _fileInfo = FileInfo ""
			--T
			_fileInfo.index = _index
			_fileInfo.active = true
			_fileInfo.FullPath = item
			_fileInfo.Directory = _ioPath.GetDirectoryName item
			_fileInfo.FileName = _ioPath.GetFileNameWithoutExtension item
			_fileInfo.Extension = _ioPath.GetExtension item
			--
			if (finditem m_excludeExtension _fileInfo.Extension == 0)then
			(
				append m_fileList _fileInfo
				_index += 1
			)
		)
	)
	--
	-- XgXV
	fn reSetListView lv =
	(
		--
		local _fileCollection = #()
		for item in m_fileList do
		(
			local _itemArray = #(
												(item.FileName + item.Extension),
												item.Directory,
												item.Extension
											)
			append _fileCollection (dotNetObject "System.Windows.Forms.ListViewItem" _itemArray)
		)
		lv.Items.Clear()
		lv.Items.AddRange _fileCollection
		--
	)
	--
	-- S`FbN
	fn allItemCheck lv flag =
	(
		local _numItem = lv.Items.count - 1
		
		for i = 0 to _numItem do
		(
			local _item = lv.Items.Item  i
			_item.Checked = flag
		)
	)
	--
	-- `FbNt@CW
	fn checkedCollector =
	(
		local _items = #()
		local _numItem = list1.Items.count - 1
		
		for i = 0 to _numItem do
		(
			local _item = list1.Items.Item  i
			if (_item.Checked) then
			(
				local _subItem0 = _item.SubItems.Item 0
				local _subItem1 = _item.SubItems.Item 1
				local _path = _subItem1.Text
				local _name = _subItem0.Text
				--
				local _fileName = _path + "\\" + _name
				--
				for _cItem in m_fileList do
				(
					if (_cItem.FullPath == _fileName) then
						append _items _cItem
				)
			)
		)
		return _items
	)
	--
	-- Xg֐
	fn initListView lv =
	(
		--
		local _colorClass = dotNetClass "System.Drawing.Color"
		lv.BackColor  = _colorClass.FromArgb  210 215 225
		lv.ForeColor = _colorClass.FromArgb 64 64 64
		lv.CheckBoxes = true
		lv.gridLines = true
		lv.LabelEdit = true;
		lv.View = (dotNetClass "System.Windows.Forms.View").Details
		lv.fullRowSelect = true
		--layout_def = #("label")
		local _layout_def = #(
								#("Name",180), 
								#( "Path",480), 
								#("Extension",60)
							)
		for item in _layout_def do
			lv.Columns.add item[1] item[2]
		--
		fileCollector()
		reSetListView lv
		allItemCheck list1 true
	) 
	--
	-- pXύX
	fn pathConvert dir =
	(
		local _returnStr = ""
		_returnStr = substituteString dir "\\" "\\\\" 
	)
	--
	-- bmptga
	fn bmp2tga item = 
	(
		pathConvert item.FullPath
		--
		local _origBitmap = openBitMap item.FullPath
		local _convBitmap = bitmap _origBitmap.width _origBitmap.height
		copy _origBitmap _convBitmap 
		_convBitmap.filename = (item.Directory + "\\" + item.FileName + ".tga")
		--
		targa.itgaio.setColorDepth 32
		targa.itgaio.setCompressed true
		targa.itgaio.setAlphaSplit false
		targa.itgaio.setPreMultAlpha true
		--
		local _frag = save _convBitmap
		--
		if (_frag != true) then
		(
			return ""
		)		
		--
		return _convBitmap.filename
	)
	--
	-- ϊ
	fn dcConvert = 
	(
		local _numItem = m_fileList.count
		--
		local _proc = dotNetObject "System.Diagnostics.Process"
		local _nvcompress = m_exeFilePath + "\\nvcompress.exe"
		--
		local _formatStr = ""
		--
		case m_compression of
		(
			1: ( _formatStr =  "-rgb")
			2: ( _formatStr =  "-bc1")
			3: ( _formatStr =  "-bc1n")
			4: ( _formatStr =  "-bc1a")
			5: ( _formatStr =  "-bc2")
			6: ( _formatStr =  "-bc3")
			7: ( _formatStr =  "-bc3n")
			8: ( _formatStr =  "-bc4")
			9: ( _formatStr =  "-bc5")
		)
		--
		local _checkedItems = checkedCollector()
		--
		for item in _checkedItems do
		(
			if ((getFiles (item.FullPath)).count != 0) then
			(
				local _inFile = item.FullPath
				local _delFlag = false
				
				if ( (item.Extension == ".bmp") or (item.Extension == ".BMP") ) then
				(
					_inFile = bmp2tga item
					_delFlag = true
				)
				
				if (_inFile != "") then
				(
					local _arg = _formatStr + " \"" + _inFile  + "\" \"" + (m_outPutFilePath + "\\" + item.FileName + ".dds") + "\""
					print _arg
					_proc.StartInfo.FileName = _nvcompress
					_proc.StartInfo.Arguments  = _arg 
					_proc.Start()
					_proc.WaitForExit()
				)
				
				if (_delFlag) then
				(
					deleteFile _inFile
				)
			)
			else
			(
				local _str = item.FileName + item.Extension + " could not be found."
				messageBox _str title:"error"
			)
		)
	)
	--
	-- RNbN
	fn columnClicked arg =
	(
		local _index = arg.Column + 1
		m_compareFlag[_index] = not m_compareFlag[_index]
		case arg.Column of
		(
			0:
			(
				qsort m_fileList compareName
			)
			1:
			(
				qsort m_fileList comparePath
			)
			2:
			(
				qsort m_fileList compareExtension
			)
		)
		reSetListView list1
		allItemCheck list1 true
	)
	--
	-- Zbg
	fn dcReset =
	(
		fileCollector()		
		reSetListView list1
		allItemCheck list1 true
	)
	--
	-- Abvf[gmF֐
	fn upCheck =
	(
		local url	= "http://www.apras.net/contents/data_dev/script/index.xml"
		--try
		(
			dotnet.loadAssembly "system.xml.dll"
			local doc = dotNetObject "System.Xml.XmlDocument"
			doc.load url
			--
			local xpath = "/softInfo/ddsConverter/latestVer"
			local root = doc.DocumentElement
			local nodeList = root.SelectNodes xpath
			local element = nodeList.Item 0
			local latastVer = element.GetAttribute "ver"
			if ((latastVer as float) > mineVersion) then
			(
				if (queryBox ("this is old version.\nupdate now ?") title:"update check !") then
				(
					ShellLaunch "http://www.apras.net/" ""
				)else(
				)
			)else
			(
				messageBox ("this is latest version.") title:"update check !"
			)
			--
		)
		/*
		catch
		(
			messageBox ("disconnect network.") title:"error"
		)
		*/
	)	
	--
	--
	------------------------------------------------------------------------
	--
	--
	-- Cxgnh`
	------------------------------------------------------------------------
	on dcRoll open do
	(
		keyInit()
		initListView list1
	)	
	
	on m_bt1 pressed do ( allItemCheck list1 true )
	
	on m_bt2 pressed do ( allItemCheck list1 false )
	
	on m_bt3 pressed do ( setOutPutPath() )
	
	on m_bt6 pressed do ( setExeFilePath() )
	
	on m_dl1 selected  index do ( compressionChange index )
	
	on m_bt4 pressed do ( dcConvert() )
	
	on m_bt5 pressed do ( dcReset() )
	
	on list1 ColumnClick args do ( columnClicked args )
	
	on m_bt7 pressed do ( upCheck() )
)
--------------------------------------------------------------------------------
createDialog dcRoll 960 284
cui.RegisterDialogBar dcRoll style:#(#cui_floatable, #cui_handles) 